;tape loader of HOVER ATTACK for PC-6001mkII

PROG	equ	0c000h
START	equ	0d430h
SIZE	equ	3000h
STACK	equ	0000h
CMTLOAD	equ	0fa61h

ROPEN	equ	1a61h
GETCMT	equ	1a70h
RCLOSE	equ	1aaah
FOUND	equ	2576h
CSRAD	equ	0fdaah
FNAME	equ	0fed1h

KEYBUF	equ	0fbb9h
GMKYBUF	equ	0fecah


;cload header
	db	0d3h,0d3h,0d3h,0d3h,0d3h,0d3h,0d3h,0d3h,0d3h,0d3h
	db	"HOVER", 00h

	org	CMTLOAD
;10 A=PEEK(&HFA5F)+PEEK(&HFA60)*256
	db	0ffh,0ffh,0ah,00h,"A",0d2h,0e3h,"(&HFA5F)"
	db	0cah,0e3h,"(&HFA60)",0cch,"256",00h
;20 EXECA+42
	db	0ffh,0ffh,14h,00h,0a5h,"A",0cah,"42",00h,00h,00h


;copy tape loader
	ld	hl,(0fa5fh)
	ld	de,CMTLOAD
	ld	bc,PROGEND-CMTLOAD
	ldir
	jp	HEAD


;load header part of main program
HEAD:
	call	ROPEN
LOOP1:
	ld	b,10
LOOP2:
	call	GETCMT
	cp	0d3h
	jr	nz,LOOP1
	djnz	LOOP2

	ld	hl,FNAME
	ld	b,6
LOOP3:
	call	GETCMT
	ld	(hl),a
	inc	hl
	djnz	LOOP3

	ld	hl,FOUND
	ld	de,(CSRAD)
	ld	bc,6
	ldir

	ld	hl,FNAME
;	ld	bc,6
	ld	c,6
	ldir

;load data part of main program
	ld	sp,STACK
	ld	hl,PROG
	ld	bc,SIZE
LOOP4:
	call	GETCMT
	ld	(hl),a
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,LOOP4
	call	RCLOSE

;setting
	xor	a
	out	(0c1h),a	;bit3: 0=320x200, 1=160x200
				;bit2: 0=graphic, 1=text
				;bit1: 0=40x20, 1=32x16
	ld	a,5
	out	(0b0h),a	;bit3: CMT relay, 0=off, 1=on
				;bit21: VRAM address
				; 00=c000(60) / 8000(60m)
				; 01=e000(60) / c000(60m)
				; 10=8000(60) / 0000(60m) *
				; 11=a000(60) / 4000(60m)
				;bit0: timer, 0=on, 1=off

	ld	a,2
	out	(0c0h),a	;color set

	ld	a,7
	out	(0a0h),a
	ld	a,38h
	out	(0a1h),a	;set PSG noise off

	di
	ld	hl,INTTBL
	ld	de,0fa02h
;	ld	bc,11*2
	ld	c,11*2
	ldir

	ld	a,0ddh
	out	(0f0h),a	;0000-7fff=internal ram (for reading)

	ei
	jp	START


INTTBL:
	dw	INTKEY		;fa02 normal key
	dw	EIRET		;fa04 RS-232C
	dw	0f74h		;fa06 2ms timer
	dw	INTKEY		;fa08 CMT read
	dw	EIRET		;fa0a ?
	dw	EIRET		;fa0c ?
	dw	EIRET		;fa0e CMT write stop
	dw	EIRET		;fa10 CMT read stop
	dw	EIRET		;fa12 CMT error
	dw	INTKEY		;fa14 CMT GRAPH key etc.
	dw	INTGAM		;fa16 reply to game key query

INTKEY:
	push	af
	call	IN90H
	ld	(KEYBUF),a
	pop	af
EIRET:
	ei
	ret

INTGAM:
	push	af
	call	IN90H
	ld	(GMKYBUF),a
	pop	af
	ei
	ret

IN90H:
	ld	a,0ch
	out	(93h),a		;disable 8255 INT for writing
IN90HLP:
	in	a,(92h)
	cpl
	and	28h
	jr	nz,IN90HLP	;wait for ibf=1,intr=1
	ld	a,0dh
	out	(93h),a		;enable 8255 INT for writing
	in	a,(90h)
	ret


PROGEND:

;cload footer
	db	00h,00h,00h,00h,00h,00h,00h,00h,00h,00h

	end
