;tape loader of HOVER ATTACK for PC-6001mkII

PROG	equ	0c000h
START	equ	0d430h
SIZE	equ	2000h
IXADR	equ	0f800h
;STACK	equ	0f900h
;STACK	equ	0dc00h
STACK	equ	0000h
INTRPT	equ	0fa61h

DISK	equ	4274h
CSRAD	equ	0fdaah
FNAME	equ	0fed1h

KEYBUF	equ	0fbb9h
GMKYBUF	equ	0fecah


	org	0f900h
	db	"SYS"

;load data part of main program
	ld	sp,STACK
	ld	ix,IXADR

	ld	bc,0101h	;track1,sector1
	ld	de,PROG
	xor	a
	ld	(ix+0),a	;drive number
	ld	(ix+11h),a	;error count
	ld	a,10h		;16 sectors
	or	a		;clear z- and c-flags for reading
	call	DISK

	ld	bc,0201h	;track2,sector1
	ld	de,PROG+1000h
	ld	a,0ch		;11 sectors
	or	a
	call	DISK

	ld	bc,0301h	;track2,sector1
	ld	de,PROG+2000h
	ld	a,10h		;16 sectors
	or	a
	call	DISK

;setting
	di
	ld	hl,INTTBL
	ld	de,0fa02h
	ld	bc,11*2
	ldir

	ld	hl,INTTBLEND
	ld	de,INTRPT
	ld	bc,PROGEND-INTRPT
	ldir

	xor	a
	out	(0c1h),a	;bit3: 0=320x200, 1=160x200
				;bit2: 0=graphic, 1=text
				;bit1: 0=40x20, 1=32x16
	ld	a,2
	out	(0c0h),a	;color set

	ld	a,5
	out	(0b0h),a	;bit3: CMT relay, 0=off, 1=on
				;bit21: VRAM address
				; 00=c000(60) / 8000(60m)
				; 01=e000(60) / c000(60m)
				; 10=8000(60) / 0000(60m) *
				; 11=a000(60) / 4000(60m)
				;bit0: timer, 0=on, 1=off
	ld	a,7
	out	(0a0h),a
	ld	a,38h
	out	(0a1h),a	;set PSG noise off
	ld	a,0ddh
	out	(0f0h),a	;0000-7fff=internal ram (for reading)

	ei
	jp	START


INTTBL:
	dw	INTKEY		;fa02 normal key
	dw	EIRET		;fa04 RS-232C
	dw	0f74h		;fa06 2ms timer
	dw	INTKEY		;fa08 CMT read
	dw	EIRET		;fa0a ?
	dw	EIRET		;fa0c ?
	dw	EIRET		;fa0e CMT write stop
	dw	EIRET		;fa10 CMT read stop
	dw	EIRET		;fa12 CMT error
	dw	INTKEY		;fa14 CMT GRAPH key etc.
	dw	INTGAM		;fa16 reply to game key query

INTTBLEND:


	org	INTRPT
INTKEY:
	push	af
	call	IN90H
	ld	(KEYBUF),a
	pop	af
EIRET:
	ei
	ret

INTGAM:
	push	af
	call	IN90H
	ld	(GMKYBUF),a
	pop	af
	ei
	ret

IN90H:
	ld	a,0ch
	out	(93h),a		;disable 8255 INT for writing
IN90HLP:
	in	a,(92h)
	cpl
	and	28h
	jr	nz,IN90HLP	;wait for ibf=1,intr=1
	ld	a,0dh
	out	(93h),a		;enable 8255 INT for writing
	in	a,(90h)
	ret


PROGEND:
	ds	0fa00h-(PROGEND-INTRPT+INTTBLEND)

	end
